!-----------------------------------------------
! stockage des résultats (format medit ou visit)
!-----------------------------------------------


module mod_sorties

  implicit none

  contains

    subroutine sortie_medit(numero,imax,jmax,f,x,y)

      !-------------------- modules -------------------------!
      use mod_precision
      !------------------------------------------------------!

      implicit none

      !---------------------- in ----------------------------!
      character(len=100), intent(in) :: numero
      integer, intent(in) :: imax,jmax      
      real(pr), dimension(0:imax+1,0:jmax+1), intent(in) :: f
      real(pr), dimension(0:imax), intent(in) :: x
      real(pr), dimension(0:jmax), intent(in) :: y
      !------------------------------------------------------!

      !--------------- variables locales --------------------!
      integer :: i,j
      character(len=100) :: fich
      !------------------------------------------------------!

      fich='SORTIES/sortie.'//trim(adjustl(numero))//'.bb'
      open(unit=1,file=fich)
      write(1,*) 2,1,imax*jmax,1
      do i=1,imax
         do j=1,jmax
            write(1,*) f(i,j)
         end do
      end do
      close(1)

      fich='SORTIES/sortie.'//trim(adjustl(numero))//'.mesh'
      open(unit=1,file=fich) 
      write(1,*) 'Dimension',2
      write(1,*)
      write(1,*) 'Vertices'
      write(1,*) (imax+1)*(jmax+1)
      do i=0,imax
         do j=0,jmax
            write(1,*) x(i),y(j),0
         end do
      end do
      write(1,*)
      write(1,*) 'Quadrilaterals'
      write(1,*) imax*jmax
      do i=1,imax
         do j=1,jmax
            write(1,*) (i-1)*(jmax+1)+j,(i)*(jmax+1)+j,(i)*(jmax+1)+(j+1),(i-1)*(jmax+1)+(j+1),0
         end do
      end do
      write(1,*) 'End'
      close(1)

    end subroutine sortie_medit

  
    subroutine sortie_visit(numero,imax,jmax,f,x,y)

      !------------------------------------------------------
      !      sorties au format vtk, 
      !      lisible par visit
      !------------------------------------------------------

      !-------------------- modules -------------------------!
      use mod_precision
      !------------------------------------------------------!

      implicit none

      !---------------------- in ----------------------------!
      character(len=100), intent(in) :: numero
      integer, intent(in) :: imax,jmax
      real(pr), dimension(0:imax+1,0:jmax+1), intent(in) :: f
      real(pr), dimension(0:imax), intent(in) :: x
      real(pr), dimension(0:jmax), intent(in) :: y
      !------------------------------------------------------!

      !--------------- variables locales --------------------!
      integer :: i,j
      character(len=100) :: fich
      !------------------------------------------------------!

      fich='SORTIES/resultats.'//trim(adjustl(numero))//'.vtk'
      open(unit=1,file=fich)
      write(1,'(1A26)') '# vtk DataFile Version 2.0'
      write(1,*) 'convection 2D'
      write(1,*) 'ASCII'
      write(1,*) 'DATASET RECTILINEAR_GRID'
      write(1,*) 'DIMENSIONS ',imax+1,jmax+1,1
      write(1,*) 'X_COORDINATES',imax+1,' double'
      do i=0,imax
         write(1,*) x(i)
      end do
      write(1,*) 'Y_COORDINATES',jmax+1,' double'
      do j=0,jmax
         write(1,*) y(j)
      end do
      write(1,*) 'Z_COORDINATES',1,' double'
      write(1,*) 0.0_pr

      write(1,*) 'CELL_DATA',imax*jmax
      write(1,*) 'SCALARS f double'
      write(1,*) 'LOOKUP_TABLE default'
      do j=1,jmax
         do i=1,imax
            write(1,*) f(i,j)
         end do
      end do
      close(1)

    end subroutine sortie_visit

end module mod_sorties
